/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.process.utils;

import it.eng.spago.base.SourceBean;
import it.eng.spago4q.bo.EOperation;
import it.eng.spago4q.bo.EOperationField;
import it.eng.spago4q.bo.InterfaceField;
import it.eng.spago4q.bo.Script;
import it.eng.spago4q.utilities.DetailS4Q2ObjectUtil;

public class DetailOperationFieldUtil extends DetailS4Q2ObjectUtil {

	private static final String DAO_NAME = "EOperationFieldDAO";
	private static final String OBJ_NAME = "EOPERATIONFIELD";

	@Override
	protected String getDAOName() {
		return DAO_NAME;
	}

	@Override
	protected Object getObjectFromRequest(SourceBean serviceRequest) {
		EOperationField toReturn = new EOperationField();
		String name = (String) serviceRequest.getAttribute("name");

		String operationId = (String) serviceRequest
				.getAttribute("Operation_Id");
		String interfaceFieldId = (String) serviceRequest
				.getAttribute("InterfaceField_Id");
		String scriptId = (String) serviceRequest.getAttribute("Script_Id");

		toReturn.setName(name);

		Script script = null;
		
		if(scriptId != null && (! scriptId.equals("-1"))) {
			script = new Script();
			script.setId(Integer.parseInt(scriptId));
		}

		
		if (interfaceFieldId != null){
			InterfaceField interfaceField = new InterfaceField();
			interfaceField.setId(Integer.parseInt(interfaceFieldId));
			toReturn.setInterfaceField(interfaceField);}

		EOperation operation = new EOperation();
		operation.setId(Integer.parseInt(operationId));


		toReturn.setEOperation(operation);
		toReturn.setScript(script);

		return toReturn;
	}

	@Override
	protected String getObjectName() {
		return OBJ_NAME;
	}

	@Override
	protected void setObjectId(Object object, Integer id) {
		((EOperationField) object).setId(id);
	}
}
