/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.source.utils;

import it.eng.spago.base.SourceBean;
import it.eng.spago4q.bo.DataSource;
import it.eng.spago4q.bo.SourceType;
import it.eng.spago4q.utilities.DetailS4Q2ObjectUtil;

public class DetailDataSourceUtil extends DetailS4Q2ObjectUtil {

	private static final String DAO_NAME = "EDataSourceDAO";
	private static final String OBJ_NAME = "DATASOURCE";
	
	private TestMessage testMessage = null;

	@Override
	protected String getDAOName() {
		return DAO_NAME;
	}

	@Override
	protected Object getObjectFromRequest(SourceBean serviceRequest) {
		DataSource toReturn = new DataSource();
		String name = (String) serviceRequest.getAttribute("name");
		String description = (String) serviceRequest
				.getAttribute("description");
		String SourceTypeId = (String) serviceRequest.getAttribute("Type_Id");

		toReturn.setName(name);
		toReturn.setDescription(description);

		SourceType sourceType = new SourceType();

		sourceType.setId(Integer.parseInt(SourceTypeId));

		toReturn.setSourceType(sourceType);

		return toReturn;
	}
	
	@Override
	public void updateObjectFromRequest(SourceBean serviceRequest, Integer id)
			throws Exception {
		super.updateObjectFromRequest(serviceRequest, id);
		String testValue = (String) serviceRequest.getAttribute("TESTDATASOURCE");
		if (testValue != null && testValue.toUpperCase().equals("TEST")){
			testMessage = SourceTypeUtil.testDataSource(id);
		}
	}
	
	@Override
	public void selectObject(Integer id, SourceBean serviceResponse)
			throws Exception {
		super.selectObject(id, serviceResponse);
		if (testMessage != null){
			serviceResponse.setAttribute("TESTRESULT", testMessage);
		}
	}

	@Override
	protected String getObjectName() {
		return OBJ_NAME;
	}

	@Override
	protected void setObjectId(Object object, Integer id) {
		((DataSource) object).setId(id);
	}

}
